<?php

namespace App\Http\Middleware;

use App\Service\EmployeeService;
use Closure;

class CheckJRFIDLogin
{
    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure  $next
     * @return mixed
     */
    public function handle($request, Closure $next)
    {
        $token = $request->header('Authorization');
        if (! isset($token)) return response()->json(['code'=>201,'msg'=>'缺少Authorization','data'=>null]);
        if(strpos($token, "Bearer ") === false) $token = "Bearer " . $token;
        $data['token'] = $token;
        $data['header'] = ["Authorization: {$token}",'Content-Type:application/json'];

        $request->common_param = $data;
        return $next($request);
    }
}
