<?php

use Illuminate\Http\Request;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/

Route::middleware('auth:api')->get('/user', function (Request $request) {
    return $request->user();
});

Route::any('login', 'Api\LoginController@login');
//站点获取
Route::any('getSite', 'Api\JRFIDController@getSite');
Route::any('getPrintData', 'Api\JRFIDController@getPrintData');
Route::any('screenPrint', 'Api\JRFIDController@screenPrint');

Route::any('testdwy','Api\TestController@testdwy');
Route::any('testdwyget','Api\TestController@testdwyget');
Route::any('testdwyput','Api\TestController@testdwyput');

Route::group(['middleware'=> ['CheckJRFIDLogin']],function ($route){
    //站点获取登录后
    $route->any('getSiteByLogin', 'Api\JRFIDController@getSite2');
    //工艺流程单
    $route->any('getFlowByProduce', 'Api\JRFIDController@getFlowByProduce');
    //生产订单
    $route->any('getProduceByContract', 'Api\JRFIDController@getProduceByContract');
    //获取班组
    $route->any('getTeam', 'Api\JRFIDController@getTeam');
    //完工
    $route->any('completionOrders', 'Api\JRFIDController@completionOrders');
    //质检
    $route->any('qualityOrders', 'Api\JRFIDController@qualityOrders');
    //（查询合同号、图号、房间号）
    $route->any('getContractDrawRoom', 'Api\JRFIDController@getContractDrawRoom');
    //(根据合同号、图号、房间号查询工艺流程单数据)
    $route->any('screenGetProFlow', 'Api\JRFIDController@screenGetProFlow');
    //收发货
    $route->any('screenSend', 'Api\JRFIDController@screenSend');
    //包装
    $route->any('screenPackage', 'Api\JRFIDController@screenPackage');
    //(根据合同号、图号、房间号查询包装单数据)
    $route->any('screenGetPackageData', 'Api\JRFIDController@screenGetPackageData');
    //(查询工艺流程单详情信息)
    $route->any('screenGetProDtData', 'Api\JRFIDController@screenGetProDtData');
});
